-----------------------------------------------------------------------------------------------
-- Client Lua Script for KuralakHelper
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- KuralakHelper Module Definition
-----------------------------------------------------------------------------------------------
local KuralakHelper = {} 
local version = 22


	local posname = {}
	posname[1] = {}
	posname[1][1] = "NE"
	posname[1][2] = "SE"
	posname[1][3] = "SW"
	posname[1][4] = "NW"
	posname[2] = {}
	posname[2][1] = "N"
	posname[2][2] = "E"
	posname[2][3] = "S"
	posname[2][4] = "W"
	posname[3] = {}
	posname[3][1] = "E"
	posname[3][2] = "S"
	posname[3][3] = "W"
	posname[3][4] = "N"
	posname[4] = {}
	posname[4][1] = ""
	posname[4][2] = ""
	posname[4][3] = ""
	posname[4][4] = ""
	local KuralakLocaleName = {
	[1] = "Kuralak the Defiler",
	[2] = "Kuralak die Schänderin",
	[3] = "Kuralak la Profanatrice"
	}
	--[[
	local KuralakLocaleName = {
	[1] = "Raid Target Dummy",
	[2] = "Kuralak die Schänderin",
	[3] = "Kuralak la Profanatrice"
	}
]]

-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function KuralakHelper:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function KuralakHelper:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 
-----------------------------------------------------------------------------------------------
-- KuralakHelper OnLoad
-----------------------------------------------------------------------------------------------
function KuralakHelper:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("KuralakHelper.xml")
	Apollo.LoadSprites("KuralakHelperSprite.xml","KHSprite")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- KuralakHelper OnDocLoaded
-----------------------------------------------------------------------------------------------
function KuralakHelper:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.Overlay = Apollo.LoadForm(self.xmlDoc, "Overlay", nil, self)
	    self.PopUp = Apollo.LoadForm(self.xmlDoc, "KHPopUp", nil, self)
		if self.Overlay == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
	    self.Overlay:Show(true)
	    self.PopUp:Show(false, true)
	
		self.Locations = {}
		self.Locations[1] = 	Vector3.New(183.84,-112.09,-498.46) --NorthEastLoc
		self.Locations[2] =		Vector3.New(176.16,-112.09,-477.32) --SouthEastLoc
		self.Locations[3] = 	Vector3.New(156.46,-112.09,-481.65)  --SouthWestLoc
		self.Locations[4] = 	Vector3.New(161.74,-112.09,-500.61)  --NorthWestLoc
		
		self.Locations[5] = 	Vector3.New(229,-112.09,-581)  --NorthEastPillarLoc
		self.Locations[6] = 	Vector3.New(260,-112.09,-490) --EastPillarLoc
		self.Locations[7] =		Vector3.New(220,-112.09,-398) --SouthEastPillarLoc
		self.Locations[8] = 	Vector3.New(114,-112.09,-398) --SouthWestPillarLoc
		self.Locations[9] = 	Vector3.New(71,-112.09,-491) --WestPillarLoc
		self.Locations[10] = 	Vector3.New(118,-112.09,-581.65)  --NorthWestPillarLoc

		Apollo.RegisterEventHandler("UnitEnteredCombat", "OnEnteredCombat", self)
    	Apollo.RegisterSlashCommand("khelper", "OnOptions", self)
		Apollo.RegisterEventHandler("UnitCreated", "OnUnitCreated", self)
		Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
		Apollo.RegisterEventHandler("KInterfaceClick", "OnInterfaceClick", self)
		
		self.checkBoxes = {}
		self.checkBoxes[1] = self.PopUp:FindChild("NEButton")
		self.checkBoxes[2] = self.PopUp:FindChild("SEButton")
		self.checkBoxes[3] = self.PopUp:FindChild("SWButton")
		self.checkBoxes[4] = self.PopUp:FindChild("NWButton")
		
		self.checkBoxes[5] = self.PopUp:FindChild("NEPButton")
		self.checkBoxes[6] = self.PopUp:FindChild("EPButton")
		self.checkBoxes[7] = self.PopUp:FindChild("SEPButton")
		self.checkBoxes[8] = self.PopUp:FindChild("SWPButton")
		self.checkBoxes[9] = self.PopUp:FindChild("WPButton")
		self.checkBoxes[10] = self.PopUp:FindChild("NWPButton")
		self.OptionsButton = self.PopUp:FindChild("OptionsButton")
		self.OptionsPopUp = self.PopUp:FindChild("OptionsWindow")
		self.DirRadioWindow = self.PopUp:FindChild("RadioButtons")

		
		if self.ISlider == nil then
			self.ISlider = 30
		end
		
		if self.bDrawLine == nil then
			self.bDrawLine = false
		end
		
		self.DirRadios = {}
		self.DirRadios[1] = self.PopUp:FindChild("NESwap")
		self.DirRadios[2] = self.PopUp:FindChild("NSwap")
		self.DirRadios[3] = self.PopUp:FindChild("NWSwap")
		
		self.Phase = 1
		self.Locale = 1
		
		local strCancel = Apollo.GetString(1)
		if strCancel == "Abbrechen" then
			self.Locale = 2
		elseif strCancel == "Annuler" then
			self.Locale = 3
		else
			self.Locale = 1
		end

		self.colors = {}
		self.colors[1] ="ff00ff00"
		self.colors[2] ="ffffff00"
		self.colors[3] ="ff0000ff"
		self.colors[4] ="ffff00ff"
		
		self.DancingWithKuralak = false

		self:FillOptionsWindow()
		
		self.player = GameLib.GetPlayerUnit()
		
		if self.player and self.player:IsInCombat() then
			self:OnEnteredCombat(self.player:GetTarget(), true)
		end
	end
end

-----------------------------------------------------------------------------------------------
-- KuralakHelperForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function KuralakHelper:OnOK()
	self.PopUp:Close() -- hide the window
	self.OptionsButton:SetCheck(false)
end

-- when the Cancel button is clicked
function KuralakHelper:OnCancel()
	self.PopUp:Close() -- hide the window
	self.Debug = false
	self.OptionsButton:SetCheck(false)
end


function KuralakHelper:OnInterfaceMenuListHasLoaded()
		Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "KuralakHelper", {"KInterfaceClick", "", ""})
end


function KuralakHelper:OnInterfaceClick()
	self:OnOptions()
end


function KuralakHelper:OnOptions()
	if not self.PopUp:IsVisible() then
		self.PopUp:Invoke()
    	Apollo.RegisterEventHandler("NextFrame", "OnNextFrame", self)
		self.Debug = true
	else
		self:OnCancel()
	end
end

-----------------------------------------------------------------------------------------------
-- KuralakHelper Instance
-----------------------------------------------------------------------------------------------
local KuralakHelperInst = KuralakHelper:new()
KuralakHelperInst:Init()


function KuralakHelper:OnNextFrame()
	self.player = GameLib.GetPlayerUnit()
	
	if self.player == nil then return end
	
	if not self.player:IsInCombat() and not self.PopUp:IsVisible() then
	  	Apollo.RemoveEventHandler("NextFrame",self)
		self.Overlay:DestroyAllPixies()
		self.Phase = 1
		self.Kuralak = nil
		self.DancingWithKuralak = false
		return
	end
	
	self:DrawHelpers()
	
	if self.DancingWithKuralak then
		self:ManagePhases()
	end
end


function KuralakHelper:ManagePhases()
	if self.Kuralak and self.Kuralak:IsValid() and self.player:IsInCombat() then 
		local percent =  self.Kuralak:GetHealth() /  self.Kuralak:GetMaxHealth()
		if percent <= 0.73 then
			self.Phase = 2
		end
	end
end


function KuralakHelper:DrawHelpers()
	self.Overlay:DestroyAllPixies()
    local pixieLocPoints = { 0, 0, 0, 0 }

	for i = 1, 10 do
		local bPassing = false
		if i > 4 and self.Phase == 1 then bPassing = true end
		if i < 5 and self.Phase == 2 then bPassing = true end

		
		if self.ButtonValue[i] and bPassing then
			local newPos = Vector3.New(self.Locations[i].x,self.Locations[i].y,self.Locations[i].z)
			local size = self.ISlider or 30
-- 			Just here so I can test in housing plot		
--			newPos.x = (self.Locations[i].x) + 1300
--			newPos.y = -714
--			newPos.z = self.Locations[i].z + 1950

			pos = GameLib.WorldLocToScreenPoint(newPos)
			if i < 5 then
				sprite =  "zonemap:UI_WorldMap_Position"
			else
				sprite = "KHSprite:PillarIcon"
			end
			 
			if i > 4 then
				if self.bDrawLine then
					local playerPos = self.player:GetPosition()
					local posbT = Vector3.New(playerPos.x,playerPos.y,playerPos.z) --NorthEastLoc
					posb = GameLib.WorldLocToScreenPoint(posbT)
					self.Overlay:AddPixie( { bLine = true, fWidth = 3,  cr = "ffffffff", loc = { fPoints = {0,0,0,0}, nOffsets = { pos.x, pos.y, posb.x, posb.y } }    } )
				end
			end
			
			self.Overlay:AddPixie( {
			strText =posname[self.DirSwap][i] or "Pillar", strSprite = sprite, cr = self.colors[i] or "ffffffff",
			strFont = "Nameplates", crText = "ffffffff",
	        loc = { fPoints = pixieLocPoints, nOffsets = { pos.x-size,pos.y-size,pos.x+size,pos.y+size  } }
	       } )
		end
	end
end


function KuralakHelper:OnEnteredCombat(unit, bInCombat)
	if unit and unit:GetName() == KuralakLocaleName[self.Locale] and bInCombat then
		self.Phase = 1
		self.Kuralak = unit
		self.DancingWithKuralak = true
	  	Apollo.RemoveEventHandler("NextFrame",self)
    	Apollo.RegisterEventHandler("NextFrame", "OnNextFrame", self)
	end
end


function KuralakHelper:OnUnitCreated(unit)
	if unit and unit:GetName() == KuralakLocaleName[self.Locale] and self.DancingWithKuralak then
		self.Phase = 1
		self.Kuralak = unit
	  	Apollo.RemoveEventHandler("NextFrame",self)
    	Apollo.RegisterEventHandler("NextFrame", "OnNextFrame", self)
	end
end


function KuralakHelper:ClearMarks( wndHandler, wndControl, eMouseButton )
	self.checkBoxes[1]:SetCheck(false)
	self.checkBoxes[2]:SetCheck(false)
	self.checkBoxes[3]:SetCheck(false)
	self.checkBoxes[4]:SetCheck(false)
	self.checkBoxes[5]:SetCheck(false)
	self.checkBoxes[6]:SetCheck(false)
	self.checkBoxes[7]:SetCheck(false)
	self.checkBoxes[8]:SetCheck(false)
	self.checkBoxes[9]:SetCheck(false)
	self.checkBoxes[10]:SetCheck(false)
	self:OnSettingChange()
end


function KuralakHelper:OnSettingChange( wndHandler, wndControl, eMouseButton )
	self.ButtonValue[1]  = self.checkBoxes[1]:IsChecked()
	self.ButtonValue[2]  = self.checkBoxes[2]:IsChecked()
	self.ButtonValue[3]  = self.checkBoxes[3]:IsChecked()
	self.ButtonValue[4]  = self.checkBoxes[4]:IsChecked()
	self.ButtonValue[5]  = self.checkBoxes[5]:IsChecked()
	self.ButtonValue[6]  = self.checkBoxes[6]:IsChecked()
	self.ButtonValue[7]  = self.checkBoxes[7]:IsChecked()
	self.ButtonValue[8]  = self.checkBoxes[8]:IsChecked()
	self.ButtonValue[9]  = self.checkBoxes[9]:IsChecked()
	self.ButtonValue[10] = self.checkBoxes[10]:IsChecked()
	
	self.ISlider = self.PopUp:FindChild("ISliderBar"):GetValue()
	self.bDrawLine = self.PopUp:FindChild("DrawLineButton"):IsChecked()
	self.DirSwap = self.PopUp:FindChild("RadioButtons"):GetRadioSel("DirectionSwapRadioGroup")
	if self.DirSwap == nil or self.DirSwap == 0	then
		self.DirSwap = 1
	end
	self:ChangeCenterLables(self.DirSwap)
	self.PopUp:FindChild("SliderValue"):SetText(self.ISlider)
end


function KuralakHelper:ChangeCenterLables(direction)
	local MapWindow = self.PopUp:FindChild("MapAndButtons")
	MapWindow:FindChild("NEButton"):SetText(posname[direction][1])
	MapWindow:FindChild("SEButton"):SetText(posname[direction][2])
	MapWindow:FindChild("SWButton"):SetText(posname[direction][3])
	MapWindow:FindChild("NWButton"):SetText(posname[direction][4])
end



function KuralakHelper:FillOptionsWindow()
	if self.ButtonValue == nil then 
		self.ButtonValue = {}
		self.ButtonValue[1] = true
		self.ButtonValue[2] = true
		self.ButtonValue[3] = true
		self.ButtonValue[4] = true
		self.ButtonValue[5] = false
		self.ButtonValue[6] = false
		self.ButtonValue[7] = false
		self.ButtonValue[8] = false
		self.ButtonValue[9] = false
		self.ButtonValue[10] = false
		self.DirSwap = 1
		self.bDrawLine = false
		self.PopUp:FindChild("RadioButtons"):SetRadioSel("DirectionSwapRadioGroup", self.DirSwap or 1)
	end

	self.checkBoxes[1]:SetCheck(self.ButtonValue[1])
	self.checkBoxes[2]:SetCheck(self.ButtonValue[2])
	self.checkBoxes[3]:SetCheck(self.ButtonValue[3])
	self.checkBoxes[4]:SetCheck(self.ButtonValue[4])
	self.checkBoxes[5]:SetCheck(self.ButtonValue[5])
	self.checkBoxes[6]:SetCheck(self.ButtonValue[6])
	self.checkBoxes[7]:SetCheck(self.ButtonValue[7])
	self.checkBoxes[8]:SetCheck(self.ButtonValue[8])
	self.checkBoxes[9]:SetCheck(self.ButtonValue[9])
	self.checkBoxes[10]:SetCheck(self.ButtonValue[10])
	self.PopUp:FindChild("DrawLineButton"):SetCheck(self.bDrawLine)
	
	if self.DirSwap == nil or self.DirSwap == 0	then
		self.DirSwap = 1
	end
	self.PopUp:FindChild("RadioButtons"):SetRadioSel("DirectionSwapRadioGroup", self.DirSwap)
	self:ChangeCenterLables(self.DirSwap)


	self.PopUp:FindChild("ISliderBar"):SetValue(self.ISlider or 30)
	self.PopUp:FindChild("SliderValue"):SetText(self.ISlider or 30)
end


function KuralakHelper:OnSave(eLevel)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	local tsave = {}
	tsave.ButtonValue = {}
	tsave.ButtonValue[1] = self.ButtonValue[1]
	tsave.ButtonValue[2] = self.ButtonValue[2]
	tsave.ButtonValue[3] = self.ButtonValue[3]
	tsave.ButtonValue[4] = self.ButtonValue[4]
	tsave.ButtonValue[5] = self.ButtonValue[5]
	tsave.ButtonValue[6] = self.ButtonValue[6]
	tsave.ButtonValue[7] = self.ButtonValue[7]
	tsave.ButtonValue[8] = self.ButtonValue[8]
	tsave.ButtonValue[9] = self.ButtonValue[9]
	tsave.ButtonValue[10] = self.ButtonValue[10]
	tsave.DirSwap = self.DirSwap
	tsave.bDrawLine = self.bDrawLine
	tsave.ISlider = self.ISlider
	return tsave
end


function KuralakHelper:OnRestore(eLevel, saveData)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	for k,v in pairs(saveData) do
	   	self[k]=v
	end
end


function KuralakHelper:OnOptionsBtn( wndHandler, wndControl, eMouseButton )
	 local OptionWindow = self.PopUp:FindChild("OptionsWindow")
	 OptionWindow:Show(not OptionWindow:IsShown())
end



